#ifndef _FILESYSTEM_H
#define _FILESYSTEM_H

#include <stddef.h>

struct _FILE;
//typedef struct _FILE FILE;

struct file_operations {
	int (*remove)(const char *filename);
	int (*rename)(const char *old, const char *new);
	struct _FILE *(*fopen)(const char * filename, const char * mode);
	int (*fclose)(struct _FILE *stream);
	int (*fgetc)(struct _FILE *stream);
	char *(*fgets)(char *s, int n, struct _FILE *stream);
	int (*fputc)(int c, struct _FILE *stream);
	int (*fputs)(const char *s, struct _FILE *stream);
	int (*ungetc)(int c, struct _FILE *stream);
	size_t (*fread)(void *ptr, size_t size, size_t nmemb, struct _FILE *stream);
	size_t (*fwrite)(const void *ptr, size_t size, size_t nmemb, struct _FILE *stream);
	int (*fseek)(struct _FILE *stream, long int offset, int whence);
	long int (*ftell)(struct _FILE *stream);
	int (*fflush)(struct _FILE *stream);
};






#endif //_FILESYSTEM_H
