#ifndef _FSCASIO_H
#define _FSCASIO_H

#include "fs.h"
#include "stdio.h"
#include "file.h"


// /!\ Warning! To Big-Endian computers ONLY!


#define CASIO_FS ((const unsigned char*)(0xA0270000))

#define CASIO_STORAGE_MEM ((const unsigned char*)(0xA0000000)) 

#define fscasio_struct(file) ((struct _fscasio_file*)file->private_data) 


struct _fscasio_fragdata {
	int fsize;
	const unsigned char *fstart;
};

struct _fscasio_file {
	const unsigned char *index;
	struct _fscasio_fragdata *frags;
	int frag_num;
	unsigned int total_size;
	int current_frag;   // The fragment number where the current position is
	int curfrag_pos;    // The position in the curren_frag
};


int fscasio_remove(const char *filename);
int fscasio_rename(const char *old, const char *new);
FILE *fscasio_fopen(const char * filename, const char * mode);
int fscasio_fclose(struct _FILE *stream);
int fscasio_fgetc(FILE *stream);
char *fscasio_fgets(char *s, int n, FILE *stream);
int fscasio_fputc(int c, FILE *stream);
int fscasio_fputs(const char *s, FILE *stream);
int fscasio_ungetc(int c, FILE *stream);
size_t fscasio_fread(void *ptr, size_t size, size_t nmemb, FILE *stream);
size_t fscasio_fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream);
int fscasio_fseek(FILE *stream, long int offset, int whence);
long int fscasio_ftell(FILE *stream);
int fscasio_fflush(FILE *stream);


//void rewind(FILE *stream);
//FILE *fscasio_freopen(const char * filename, const char * mode, FILE * stream);
//void fscasio_setbuf(FILE * stream, char * buf);
//int fscasio_setvbuf(FILE * restrict stream, char * buf, int mode, size_t size);
//int fprintf(FILE * restrict stream, const char * restrict format, ...);
//int fscanf(FILE * restrict stream, const char * restrict format, ...);
//int printf(const char * restrict format, ...);
//int scanf(const char * restrict format, ...);
//int snprintf(char * restrict s, size_t n, const char * restrict format, ...);
//int sprintf(char * restrict s, const char * restrict format, ...);
//int sscanf(const char * restrict s, const char * restrict format, ...);
//int vfprintf(FILE * restrict stream, const char * restrict format, va_list arg);
//int vfscanf(FILE * restrict stream, const char * restrict format, va_list arg);
//int vprintf(const char * restrict format, va_list arg);
//int vscanf(const char * restrict format, va_list arg);
//int vsnprintf(char * restrict s, size_t n, const char * restrict format, va_list arg);
//int vsprintf(char * restrict s, const char * restrict format, va_list arg);
//int vsscanf(const char * restrict s, const char * restrict format, va_list arg);
//int fgetpos(FILE * restrict stream, fpos_t * restrict pos);
//int fsetpos(FILE *stream, const fpos_t *pos);
//int getc(FILE *stream);
//int getchar(void);
//char *gets(char *s);
//int putc(int c, FILE *stream);
//int putchar(int c);
//int puts(const char *s);


#endif //_FSCASIO_H
