#include <fxlib.h>
#include <stdarg.h>
#include <stdlib.h> // malloc
#include "stdio.h"
#include "file.h"
#include "fscasio.h"



#define PAGESTATUS_NORMAL 		0x0000
#define PAGESTATUS_UNUSED 		0xFFFF
#define PAGESTATUS_FILETABLE	0x00FF

#define HEADER_SIZE				0x20
#define PREHEADER_SIZE			0x08
#define FILENAME_SIZE           0x18

//First file header byte value :
#define FILE_HEADER_DELETED		0x01
#define FILE_HEADER_START		0x51
//Second file header byte value :
#define FILE_HEADER_FILE		0x20
#define FILE_HEADER_POSTFILE	0x30
#define FILE_HEADER_DIR			0x10



void intToString (int n, char* string);

void intToHexaString (unsigned int n, int digits, char* string);


int main(int a, int b) {
	int i, j, k, stop;
	int size, pos;
	unsigned int byteRead;
	unsigned short tmp;
	unsigned int key, key2;
	char str[30];
	char str2[40];

	FILE *ftest;
	ftest = fopen("/fls0/module.c", "r");

	if(ftest == NULL) {
		Bdisp_AllClr_DDVRAM();
		locate(1,1);
		Print("File doesn't exist.");
		GetKey(&key);
	}

	pos = 0;
	size = 0;

	//
	// Printing files data on the screen :
	//
	stop = 0;
	pos = 0;
	while(!stop) {
		if(key != KEY_CTRL_EXE) fseek(ftest, pos, SEEK_SET);
		//byteRead = fread(str2, sizeof(char), size, ftest);
		fgets(str2, size, ftest);
		//for(byteRead=0; byteRead<size && (str2[byteRead]=fgetc(ftest))!=EOF; byteRead++); 
		//str2[byteRead] = 0;
		
		Bdisp_AllClr_DDVRAM();

		struct _fscasio_file *pdata = (struct _fscasio_file *)ftest->private_data;

		locate(1,1);
		Print("README ");
		intToHexaString((unsigned int)ftest, 8, str);
		Print("0x");
		Print(str);
		
		locate(1,2);
		Print("Size : ");
		intToHexaString(pdata->frags[0].fsize, 8, str);
		Print("0x");
		Print(str);

		locate(1,3);
		Print("File pos : ");
		intToString(ftest->pos, str);
		Print(str);

		locate(1,4);
		Print("p : ");
		intToString(pos, str);
		Print(str);

		locate(1,5);
		Print("s : ");
		intToString(size, str);
		Print(str);

		locate(1,6);
		Print("R Size : ");
		intToString(byteRead, str);
		Print(str);

		locate(1,7);
		Print("R : ");
		Print(str2);

		GetKey(&key);
		if(key == KEY_CTRL_LEFT) pos--;
		else if(key == KEY_CTRL_RIGHT) pos++;
		else if(key == KEY_CTRL_UP) size++;
		else if(key == KEY_CTRL_DOWN) size--;
		else if(key == KEY_CTRL_EXE) pos = ftell(ftest);

		if(pos<0) pos=0;
		if(size<0) size=0;

		if(key == KEY_CTRL_EXIT) stop=1;
		 
		//if(pos<0) pos=0;
		//else if(pos >= g_filesNumber) pos = g_filesNumber-1;
	}
	
	fclose(ftest);
}



void intToString (int n, char* string) {
	int  i;
	int  cpt;
	int start = 0;
  	
	if (n<0) {
		start=1;
		string[0] = '-';
		n *= -1;
	}
	for (i = 1, cpt = 1; n / i >= 10; i *= 10, cpt++);
	for (cpt = start; i; cpt++, i /= 10) string[cpt] = (n / i) % 10 + '0';
	string[cpt] = '\0';
}


void intToHexaString (unsigned int n, int digits, char* string) {
	int i, cpt;
	char tmp;

	if(digits > 8) digits=8;	
	
	for(i=digits-1, cpt=0; i >= 0; i--, cpt++) {
		tmp = (n & (0x0F<<(i<<2))) >> (i<<2);
		if(tmp<10) string[cpt]=tmp+'0';
		else string[cpt] = tmp+'A'-10;
	}
	string[cpt] = '\0';
}


